Backend API
$(() => {
$('#card-view').dxCardView({
dataSource: employees,
keyExpr: 'ID',
cardMinWidth: 300,
cardsPerRow: 'auto',
paging: {
pageSize: 4,
},
cardCover: {
imageExpr: ({ First_Name, Last_Name }) => `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`,
altExpr: ({ First_Name, Last_Name }) => `Photo of ${First_Name} ${Last_Name}`,
},
columns: [
{
dataField: 'Status',
fieldValueTemplate({ field: { value } }) {
return $('<div>')
.append(
$('<div>').addClass('indicator'),
)
.append(
$('<div>').text(value),
)
.addClass('status')
.toggleClass('status--salaried', value === 'Salaried')
.toggleClass('status--commission', value === 'Commission')
.toggleClass('status--terminated', value === 'Terminated');
},
allowSearch: false,
},
{
caption: 'Full Name',
allowFiltering: true,
allowSorting: true,
calculateFieldValue({ First_Name, Last_Name }) {
return `${First_Name} ${Last_Name}`;
},
},
{
caption: 'Position',
dataField: 'Title',
},
'Department',
'Mobile_Phone',
{
dataField: 'Email',
fieldValueTemplate({ field: { value, text } }) {
return $('<a>')
.attr('href', `mailto:${value}`)
.text(text);
},
allowSearch: false,
},
{
caption: 'Address',
allowFiltering: true,
allowSorting: true,
calculateFieldValue({ State, City }) {
return `${City}, ${State}`;
},
},
],
cardFooterTemplate() {
return $('<div>')
.addClass('card-footer')
.append(
$('<div>').dxButton({
text: 'Call',
icon: 'tel',
type: 'default',
stylingMode: 'contained',
onClick() {
DevExpress.ui.notify({
message: 'The "Call" button is clicked.',
maxWidth: 560,
});
},
}),
$('<div>').dxButton({
text: 'Send Email',
icon: 'message',
type: 'default',
stylingMode: 'contained',
onClick() {
DevExpress.ui.notify({
message: 'The "Send Email" button is clicked.',
maxWidth: 560,
});
},
}),
);
},
selection: {
mode: 'multiple',
},
headerFilter: {
visible: true,
},
searchPanel: {
visible: true,
},
}).dxCardView('instance');
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="js/dx.all.js?v=25.2.6"></script>
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="card-view"></div>
</div>
</body>
</html>
.card-footer {
display: flex;
padding: 12px;
gap: 8px;
}
.card-footer > * {
flex-grow: 1;
width: 100%
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
const employees = [{
ID: 3,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 4,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 5,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 6,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 7,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 10,
First_Name: 'Kevin',
Last_Name: 'Carter',
Prefix: 'Mr.',
Title: 'Shipping Manager',
City: 'Los Angeles',
State: 'California',
Email: 'kevinc@dx-email.com',
Mobile_Phone: '+1 (213) 555-2840',
Birth_Date: '1978-01-09',
Hire_Date: '2009-08-11',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 14,
First_Name: 'Victor',
Last_Name: 'Norris',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'victorn@dx-email.com',
Mobile_Phone: '+1 (213) 555-9278',
Birth_Date: '1986-07-23',
Hire_Date: '2012-07-23',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 15,
First_Name: 'Mary',
Last_Name: 'Stern',
Prefix: 'Ms.',
Title: 'Shipping Assistant',
City: 'Glendale',
State: 'California',
Email: 'marys@dx-email.com',
Mobile_Phone: '+1 (818) 555-7857',
Birth_Date: '1982-04-08',
Hire_Date: '2012-08-12',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 16,
First_Name: 'Robin',
Last_Name: 'Cosworth',
Prefix: 'Mrs.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'robinc@dx-email.com',
Mobile_Phone: '+1 (818) 555-0942',
Birth_Date: '1981-06-12',
Hire_Date: '2012-09-01',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 17,
First_Name: 'Kelly',
Last_Name: 'Rodriguez',
Prefix: 'Ms.',
Title: 'Support Assistant',
City: 'Glendale',
State: 'California',
Email: 'kellyr@dx-email.com',
Mobile_Phone: '+1 (818) 555-9248',
Birth_Date: '1988-05-11',
Hire_Date: '2012-10-13',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 18,
First_Name: 'James',
Last_Name: 'Anderson',
Prefix: 'Mr.',
Title: 'Support Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'jamesa@dx-email.com',
Mobile_Phone: '+1 (323) 555-4702',
Birth_Date: '1987-01-29',
Hire_Date: '2012-10-18',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 20,
First_Name: 'Olivia',
Last_Name: 'Peyton',
Prefix: 'Mrs.',
Title: 'Sales Assistant',
City: 'San Pedro',
State: 'California',
Email: 'oliviap@dx-email.com',
Mobile_Phone: '+1 (310) 555-2728',
Birth_Date: '1981-06-03',
Hire_Date: '2012-05-14',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 21,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 22,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 25,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 26,
First_Name: 'Marcus',
Last_Name: 'Orbison',
Prefix: 'Mr.',
Title: 'Travel Coordinator',
City: 'Los Angeles',
State: 'California',
Email: 'marcuso@dx-email.com',
Mobile_Phone: '+1 (213) 555-7098',
Birth_Date: '1982-03-02',
Hire_Date: '2005-05-19',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 28,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 29,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 32,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 33,
First_Name: 'Leah',
Last_Name: 'Simpson',
Prefix: 'Mrs.',
Title: 'Test Coordinator',
City: 'Whittier',
State: 'California',
Email: 'leahs@dx-email.com',
Mobile_Phone: '+1 (562) 559-5830',
Birth_Date: '1983-04-19',
Hire_Date: '2009-02-14',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 36,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 38,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 40,
First_Name: 'Lucy',
Last_Name: 'Ball',
Prefix: 'Ms.',
Title: 'Sales Assistant',
City: 'Pacific Palisades',
State: 'California',
Email: 'lucyb@dx-email.com',
Mobile_Phone: '+1 (310) 555-3357',
Birth_Date: '1986-08-09',
Hire_Date: '2006-07-19',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 44,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 45,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 47,
First_Name: 'Lincoln',
Last_Name: 'Bartlett',
Prefix: 'Mr.',
Title: 'Sales Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'lincolnb@dx-email.com',
Mobile_Phone: '+1 (213) 555-8272',
Birth_Date: '1990-08-02',
Hire_Date: '2012-05-11',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 48,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
Department: 'Engineering',
}, {
ID: 50,
First_Name: 'Dallas',
Last_Name: 'Lou',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'dallas@dx-email.com',
Mobile_Phone: '+1 (213) 555-8357',
Birth_Date: '1994-08-19',
Hire_Date: '2012-06-18',
Status: 'Terminated',
Department: 'Shipping',
}, {
ID: 51,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
Department: 'Engineering',
}];
DevExtreme JavaScript CardView ships with the following built-in data management options:
- Sorting
- Paging
- Column reordering
- Column visibility control
- Editing
- Filtering
- Searching
- Data selection
Each card within the JavaScript CardView is customizable.

Backend API
<div class="demo-container">
<dx-card-view
[dataSource]="employees"
keyExpr="ID"
[cardMinWidth]="300"
cardsPerRow="auto"
cardFooterTemplate="footerTemplate"
>
<dxo-card-view-paging [pageSize]="4"></dxo-card-view-paging>
<dxo-card-view-header-filter [visible]="true"></dxo-card-view-header-filter>
<dxo-card-view-search-panel [visible]="true"></dxo-card-view-search-panel>
<dxo-card-view-selection mode="multiple"></dxo-card-view-selection>
<dxo-card-view-card-cover
[imageExpr]="imageExpr"
[altExpr]="altExpr"
></dxo-card-view-card-cover>
<dxi-card-view-column
dataField="Status"
fieldValueTemplate="statusTemplate"
[allowSearch]="false"
></dxi-card-view-column>
<dxi-card-view-column
caption="Full Name"
[calculateFieldValue]="calculateFullName"
[allowFiltering]="true"
[allowSorting]="true"
></dxi-card-view-column>
<dxi-card-view-column
caption="Position"
dataField="Title"
></dxi-card-view-column>
<dxi-card-view-column dataField="Department"></dxi-card-view-column>
<dxi-card-view-column dataField="Mobile_Phone"></dxi-card-view-column>
<dxi-card-view-column
dataField="Email"
fieldValueTemplate="emailTemplate"
[allowSearch]="false"
></dxi-card-view-column>
<dxi-card-view-column
caption="Address"
[calculateFieldValue]="calculateAddress"
[allowFiltering]="true"
[allowSorting]="true"
></dxi-card-view-column>
<div
*dxTemplate="let params of 'statusTemplate'"
class="status"
[class.status--salaried]="params.field.value === 'Salaried'"
[class.status--commission]="params.field.value === 'Commission'"
[class.status--terminated]="params.field.value === 'Terminated'"
>
<span class="indicator"></span>
<span>{{ params.field.value }}</span>
</div>
<div *dxTemplate="let params of 'emailTemplate'">
<a href="mailto:{{ params.field.value }}">{{ params.field.text }}</a>
</div>
<div *dxTemplate="let params of 'footerTemplate'" class="card-footer">
<dx-button
text="Call"
icon="tel"
type="default"
stylingMode="contained"
(onClick)="showNotify('Call')"
></dx-button>
<dx-button
text="Send Email"
icon="message"
type="default"
stylingMode="contained"
(onClick)="showNotify('Send Email')"
></dx-button>
</div>
</dx-card-view>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core';
import { DxCardViewModule, DxCardViewComponent, DxButtonModule } from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import { AppService, Employee } from './app.service';
if (!document.location.host.includes('localhost')) {
enableProdMode();
}
let modulePrefix = '';
// @ts-expect-error
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxCardViewModule,
DxButtonModule,
],
})
export class AppComponent {
@ViewChild(DxCardViewComponent, { static: true }) cardView: DxCardViewComponent;
employees: Employee[];
constructor(service: AppService) {
this.employees = service.getEmployees();
}
imageExpr({ First_Name, Last_Name }: Employee): string {
return `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`;
}
altExpr({ First_Name, Last_Name }: Employee): string {
return `Photo of ${First_Name} ${Last_Name}`;
}
calculateFullName({ First_Name, Last_Name }: Employee): string {
return `${First_Name} ${Last_Name}`;
}
calculateAddress({ State, City }: Employee): string {
return `${City}, ${State}`;
}
showNotify(text: string) {
notify({
message: `The "${text}" button is clicked.`,
maxWidth: 560,
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
.card-footer {
display: flex;
padding: 12px;
gap: 8px;
}
.card-footer > * {
flex-grow: 1;
width: 100%
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
import { Injectable } from '@angular/core';
export interface Employee {
ID: number;
First_Name: string;
Last_Name: string;
Prefix: string;
Title: string;
City: string;
State: string;
Email: string;
Mobile_Phone: string;
Birth_Date: string;
Hire_Date: string;
Department: string;
Status: string;
}
const employees: Employee[] = [{
ID: 3,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 4,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 5,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 6,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 7,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 10,
First_Name: 'Kevin',
Last_Name: 'Carter',
Prefix: 'Mr.',
Title: 'Shipping Manager',
City: 'Los Angeles',
State: 'California',
Email: 'kevinc@dx-email.com',
Mobile_Phone: '+1 (213) 555-2840',
Birth_Date: '1978-01-09',
Hire_Date: '2009-08-11',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 14,
First_Name: 'Victor',
Last_Name: 'Norris',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'victorn@dx-email.com',
Mobile_Phone: '+1 (213) 555-9278',
Birth_Date: '1986-07-23',
Hire_Date: '2012-07-23',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 15,
First_Name: 'Mary',
Last_Name: 'Stern',
Prefix: 'Ms.',
Title: 'Shipping Assistant',
City: 'Glendale',
State: 'California',
Email: 'marys@dx-email.com',
Mobile_Phone: '+1 (818) 555-7857',
Birth_Date: '1982-04-08',
Hire_Date: '2012-08-12',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 16,
First_Name: 'Robin',
Last_Name: 'Cosworth',
Prefix: 'Mrs.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'robinc@dx-email.com',
Mobile_Phone: '+1 (818) 555-0942',
Birth_Date: '1981-06-12',
Hire_Date: '2012-09-01',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 17,
First_Name: 'Kelly',
Last_Name: 'Rodriguez',
Prefix: 'Ms.',
Title: 'Support Assistant',
City: 'Glendale',
State: 'California',
Email: 'kellyr@dx-email.com',
Mobile_Phone: '+1 (818) 555-9248',
Birth_Date: '1988-05-11',
Hire_Date: '2012-10-13',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 18,
First_Name: 'James',
Last_Name: 'Anderson',
Prefix: 'Mr.',
Title: 'Support Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'jamesa@dx-email.com',
Mobile_Phone: '+1 (323) 555-4702',
Birth_Date: '1987-01-29',
Hire_Date: '2012-10-18',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 20,
First_Name: 'Olivia',
Last_Name: 'Peyton',
Prefix: 'Mrs.',
Title: 'Sales Assistant',
City: 'San Pedro',
State: 'California',
Email: 'oliviap@dx-email.com',
Mobile_Phone: '+1 (310) 555-2728',
Birth_Date: '1981-06-03',
Hire_Date: '2012-05-14',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 21,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 22,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 25,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 26,
First_Name: 'Marcus',
Last_Name: 'Orbison',
Prefix: 'Mr.',
Title: 'Travel Coordinator',
City: 'Los Angeles',
State: 'California',
Email: 'marcuso@dx-email.com',
Mobile_Phone: '+1 (213) 555-7098',
Birth_Date: '1982-03-02',
Hire_Date: '2005-05-19',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 28,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 29,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 32,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 33,
First_Name: 'Leah',
Last_Name: 'Simpson',
Prefix: 'Mrs.',
Title: 'Test Coordinator',
City: 'Whittier',
State: 'California',
Email: 'leahs@dx-email.com',
Mobile_Phone: '+1 (562) 559-5830',
Birth_Date: '1983-04-19',
Hire_Date: '2009-02-14',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 36,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 38,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 40,
First_Name: 'Lucy',
Last_Name: 'Ball',
Prefix: 'Ms.',
Title: 'Sales Assistant',
City: 'Pacific Palisades',
State: 'California',
Email: 'lucyb@dx-email.com',
Mobile_Phone: '+1 (310) 555-3357',
Birth_Date: '1986-08-09',
Hire_Date: '2006-07-19',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 44,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 45,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 47,
First_Name: 'Lincoln',
Last_Name: 'Bartlett',
Prefix: 'Mr.',
Title: 'Sales Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'lincolnb@dx-email.com',
Mobile_Phone: '+1 (213) 555-8272',
Birth_Date: '1990-08-02',
Hire_Date: '2012-05-11',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 48,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
Department: 'Engineering',
}, {
ID: 50,
First_Name: 'Dallas',
Last_Name: 'Lou',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'dallas@dx-email.com',
Mobile_Phone: '+1 (213) 555-8357',
Birth_Date: '1994-08-19',
Hire_Date: '2012-06-18',
Status: 'Terminated',
Department: 'Shipping',
}, {
ID: 51,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
Department: 'Engineering',
}];
@Injectable({
providedIn: 'root',
})
export class AppService {
getEmployees(): Employee[] {
return employees;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
DevExtreme CardView ships with the following built-in data management options:
- Sorting
- Paging
- Column reordering
- Column visibility control
- Editing
- Filtering
- Searching
- Data selection
Each card within the CardView is customizable.

Backend API
import React, { useRef } from 'react';
import CardView, {
CardCover, Column, Selection, Paging, HeaderFilter, SearchPanel,
} from 'devextreme-react/card-view';
import type { CardViewRef, CardViewTypes } from 'devextreme-react/card-view';
import Button from 'devextreme-react/button';
import notify from 'devextreme/ui/notify';
import { employees } from './data.ts';
import type { Employee } from './data.ts';
function imageExpr({ First_Name, Last_Name }: Employee): string {
return `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`;
}
function altExpr({ First_Name, Last_Name }: Employee): string {
return `Photo of ${First_Name} ${Last_Name}`;
}
function calculateFullName({ First_Name, Last_Name }: Employee): string {
return `${First_Name} ${Last_Name}`;
}
function calculateAddress({ State, City }: Employee): string {
return `${City}, ${State}`;
}
function notifyCall() {
notify({
message: 'The "Call" button is clicked.',
maxWidth: 560,
});
}
function notifySendEmail() {
notify({
message: 'The "Send Email" button is clicked.',
maxWidth: 560,
});
}
function CardFooterComponent() {
return <div className='card-footer'>
<Button
text="Call"
icon="tel"
type="default"
stylingMode="contained"
onClick={notifyCall}
/>
<Button
text="Send Email"
icon="message"
type="default"
stylingMode="contained"
onClick={notifySendEmail}
/>
</div>;
}
function StatusComponent({ data }: { data: CardViewTypes.FieldTemplateData }) {
const classNameMap = {
Salaried: 'status--salaried',
Commission: 'status--commission',
Terminated: 'status--terminated',
};
const className = classNameMap[data.field.value as Employee['Status']];
return (
<div className={`status ${className}`}>
<div className="indicator"></div>
<div>{ data.field.value }</div>
</div>
);
}
function EmailComponent({ data }: { data: CardViewTypes.FieldTemplateData }) {
return (
<a href={`mailto:${data.field.value}`}>{data.field.text}</a>
);
}
function App() {
const cardView = useRef<CardViewRef>(null);
return (
<CardView
dataSource={employees}
keyExpr="ID"
cardMinWidth={300}
cardsPerRow="auto"
cardFooterComponent={CardFooterComponent}
ref={cardView}
>
<Paging
pageSize={4}
/>
<HeaderFilter
visible={true}
/>
<SearchPanel
visible={true}
/>
<Selection mode="multiple" />
<CardCover
imageExpr={imageExpr}
altExpr={altExpr}
/>
<Column
dataField="Status"
fieldValueComponent={StatusComponent}
allowSearch={false}
/>
<Column
caption="Full Name"
allowFiltering={true}
allowSorting={true}
calculateFieldValue={calculateFullName}
/>
<Column
caption="Position"
dataField="Title"
/>
<Column
dataField="Department"
/>
<Column
dataField="Mobile_Phone"
/>
<Column
dataField="Email"
fieldValueComponent={EmailComponent}
allowSearch={false}
/>
<Column
caption="Address"
allowFiltering={true}
allowSorting={true}
calculateFieldValue={calculateAddress}
/>
</CardView>
);
}
export default App;
import React, { useRef } from 'react';
import CardView, {
CardCover,
Column,
Selection,
Paging,
HeaderFilter,
SearchPanel,
} from 'devextreme-react/card-view';
import Button from 'devextreme-react/button';
import notify from 'devextreme/ui/notify';
import { employees } from './data.js';
function imageExpr({ First_Name, Last_Name }) {
return `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`;
}
function altExpr({ First_Name, Last_Name }) {
return `Photo of ${First_Name} ${Last_Name}`;
}
function calculateFullName({ First_Name, Last_Name }) {
return `${First_Name} ${Last_Name}`;
}
function calculateAddress({ State, City }) {
return `${City}, ${State}`;
}
function notifyCall() {
notify({
message: 'The "Call" button is clicked.',
maxWidth: 560,
});
}
function notifySendEmail() {
notify({
message: 'The "Send Email" button is clicked.',
maxWidth: 560,
});
}
function CardFooterComponent() {
return (
<div className="card-footer">
<Button
text="Call"
icon="tel"
type="default"
stylingMode="contained"
onClick={notifyCall}
/>
<Button
text="Send Email"
icon="message"
type="default"
stylingMode="contained"
onClick={notifySendEmail}
/>
</div>
);
}
function StatusComponent({ data }) {
const classNameMap = {
Salaried: 'status--salaried',
Commission: 'status--commission',
Terminated: 'status--terminated',
};
const className = classNameMap[data.field.value];
return (
<div className={`status ${className}`}>
<div className="indicator"></div>
<div>{data.field.value}</div>
</div>
);
}
function EmailComponent({ data }) {
return <a href={`mailto:${data.field.value}`}>{data.field.text}</a>;
}
function App() {
const cardView = useRef(null);
return (
<CardView
dataSource={employees}
keyExpr="ID"
cardMinWidth={300}
cardsPerRow="auto"
cardFooterComponent={CardFooterComponent}
ref={cardView}
>
<Paging pageSize={4} />
<HeaderFilter visible={true} />
<SearchPanel visible={true} />
<Selection mode="multiple" />
<CardCover
imageExpr={imageExpr}
altExpr={altExpr}
/>
<Column
dataField="Status"
fieldValueComponent={StatusComponent}
allowSearch={false}
/>
<Column
caption="Full Name"
allowFiltering={true}
allowSorting={true}
calculateFieldValue={calculateFullName}
/>
<Column
caption="Position"
dataField="Title"
/>
<Column dataField="Department" />
<Column dataField="Mobile_Phone" />
<Column
dataField="Email"
fieldValueComponent={EmailComponent}
allowSearch={false}
/>
<Column
caption="Address"
allowFiltering={true}
allowSorting={true}
calculateFieldValue={calculateAddress}
/>
</CardView>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export interface Employee {
ID: number;
First_Name: string;
Last_Name: string;
Prefix: string;
Title: string;
City: string;
State: string;
Email: string;
Mobile_Phone: string;
Birth_Date: string;
Hire_Date: string;
Department: string;
Status: 'Salaried' | 'Commission' | 'Terminated';
}
export const employees: Employee[] = [{
ID: 3,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '(310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 4,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '(818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 5,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '(818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 6,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '(626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 7,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '(562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 10,
First_Name: 'Kevin',
Last_Name: 'Carter',
Prefix: 'Mr.',
Title: 'Shipping Manager',
City: 'Los Angeles',
State: 'California',
Email: 'kevinc@dx-email.com',
Mobile_Phone: '(213) 555-2840',
Birth_Date: '1978-01-09',
Hire_Date: '2009-08-11',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 14,
First_Name: 'Victor',
Last_Name: 'Norris',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'victorn@dx-email.com',
Mobile_Phone: '(213) 555-9278',
Birth_Date: '1986-07-23',
Hire_Date: '2012-07-23',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 15,
First_Name: 'Mary',
Last_Name: 'Stern',
Prefix: 'Ms.',
Title: 'Shipping Assistant',
City: 'Glendale',
State: 'California',
Email: 'marys@dx-email.com',
Mobile_Phone: '(818) 555-7857',
Birth_Date: '1982-04-08',
Hire_Date: '2012-08-12',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 16,
First_Name: 'Robin',
Last_Name: 'Cosworth',
Prefix: 'Mrs.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'robinc@dx-email.com',
Mobile_Phone: '(818) 555-0942',
Birth_Date: '1981-06-12',
Hire_Date: '2012-09-01',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 17,
First_Name: 'Kelly',
Last_Name: 'Rodriguez',
Prefix: 'Ms.',
Title: 'Support Assistant',
City: 'Glendale',
State: 'California',
Email: 'kellyr@dx-email.com',
Mobile_Phone: '(818) 555-9248',
Birth_Date: '1988-05-11',
Hire_Date: '2012-10-13',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 18,
First_Name: 'James',
Last_Name: 'Anderson',
Prefix: 'Mr.',
Title: 'Support Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'jamesa@dx-email.com',
Mobile_Phone: '(323) 555-4702',
Birth_Date: '1987-01-29',
Hire_Date: '2012-10-18',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 20,
First_Name: 'Olivia',
Last_Name: 'Peyton',
Prefix: 'Mrs.',
Title: 'Sales Assistant',
City: 'San Pedro',
State: 'California',
Email: 'oliviap@dx-email.com',
Mobile_Phone: '(310) 555-2728',
Birth_Date: '1981-06-03',
Hire_Date: '2012-05-14',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 21,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '(310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 22,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '(213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 25,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '(626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 26,
First_Name: 'Marcus',
Last_Name: 'Orbison',
Prefix: 'Mr.',
Title: 'Travel Coordinator',
City: 'Los Angeles',
State: 'California',
Email: 'marcuso@dx-email.com',
Mobile_Phone: '(213) 555-7098',
Birth_Date: '1982-03-02',
Hire_Date: '2005-05-19',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 28,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '(818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 29,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '(818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 32,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '(714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 33,
First_Name: 'Leah',
Last_Name: 'Simpson',
Prefix: 'Mrs.',
Title: 'Test Coordinator',
City: 'Whittier',
State: 'California',
Email: 'leahs@dx-email.com',
Mobile_Phone: '(562) 559-5830',
Birth_Date: '1983-04-19',
Hire_Date: '2009-02-14',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 36,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '(323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 38,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '(805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 40,
First_Name: 'Lucy',
Last_Name: 'Ball',
Prefix: 'Ms.',
Title: 'Sales Assistant',
City: 'Pacific Palisades',
State: 'California',
Email: 'lucyb@dx-email.com',
Mobile_Phone: '(310) 555-3357',
Birth_Date: '1986-08-09',
Hire_Date: '2006-07-19',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 44,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '(925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 45,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '(925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 47,
First_Name: 'Lincoln',
Last_Name: 'Bartlett',
Prefix: 'Mr.',
Title: 'Sales Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'lincolnb@dx-email.com',
Mobile_Phone: '(213) 555-8272',
Birth_Date: '1990-08-02',
Hire_Date: '2012-05-11',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 48,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '(213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
Department: 'Engineering',
}, {
ID: 50,
First_Name: 'Dallas',
Last_Name: 'Lou',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'dallas@dx-email.com',
Mobile_Phone: '(213) 555-8357',
Birth_Date: '1994-08-19',
Hire_Date: '2012-06-18',
Status: 'Terminated',
Department: 'Shipping',
}, {
ID: 51,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '(213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
Department: 'Engineering',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employees = [
{
ID: 3,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '(310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
Department: 'Management',
},
{
ID: 4,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '(818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
Department: 'Management',
},
{
ID: 5,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '(818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
Department: 'Human Resources',
},
{
ID: 6,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '(626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 7,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '(562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
Department: 'Human Resources',
},
{
ID: 10,
First_Name: 'Kevin',
Last_Name: 'Carter',
Prefix: 'Mr.',
Title: 'Shipping Manager',
City: 'Los Angeles',
State: 'California',
Email: 'kevinc@dx-email.com',
Mobile_Phone: '(213) 555-2840',
Birth_Date: '1978-01-09',
Hire_Date: '2009-08-11',
Status: 'Salaried',
Department: 'Shipping',
},
{
ID: 14,
First_Name: 'Victor',
Last_Name: 'Norris',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'victorn@dx-email.com',
Mobile_Phone: '(213) 555-9278',
Birth_Date: '1986-07-23',
Hire_Date: '2012-07-23',
Status: 'Salaried',
Department: 'Shipping',
},
{
ID: 15,
First_Name: 'Mary',
Last_Name: 'Stern',
Prefix: 'Ms.',
Title: 'Shipping Assistant',
City: 'Glendale',
State: 'California',
Email: 'marys@dx-email.com',
Mobile_Phone: '(818) 555-7857',
Birth_Date: '1982-04-08',
Hire_Date: '2012-08-12',
Status: 'Salaried',
Department: 'Shipping',
},
{
ID: 16,
First_Name: 'Robin',
Last_Name: 'Cosworth',
Prefix: 'Mrs.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'robinc@dx-email.com',
Mobile_Phone: '(818) 555-0942',
Birth_Date: '1981-06-12',
Hire_Date: '2012-09-01',
Status: 'Salaried',
Department: 'Shipping',
},
{
ID: 17,
First_Name: 'Kelly',
Last_Name: 'Rodriguez',
Prefix: 'Ms.',
Title: 'Support Assistant',
City: 'Glendale',
State: 'California',
Email: 'kellyr@dx-email.com',
Mobile_Phone: '(818) 555-9248',
Birth_Date: '1988-05-11',
Hire_Date: '2012-10-13',
Status: 'Salaried',
Department: 'Support',
},
{
ID: 18,
First_Name: 'James',
Last_Name: 'Anderson',
Prefix: 'Mr.',
Title: 'Support Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'jamesa@dx-email.com',
Mobile_Phone: '(323) 555-4702',
Birth_Date: '1987-01-29',
Hire_Date: '2012-10-18',
Status: 'Salaried',
Department: 'Support',
},
{
ID: 20,
First_Name: 'Olivia',
Last_Name: 'Peyton',
Prefix: 'Mrs.',
Title: 'Sales Assistant',
City: 'San Pedro',
State: 'California',
Email: 'oliviap@dx-email.com',
Mobile_Phone: '(310) 555-2728',
Birth_Date: '1981-06-03',
Hire_Date: '2012-05-14',
Status: 'Salaried',
Department: 'Sales',
},
{
ID: 21,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '(310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 22,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '(213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 25,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '(626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 26,
First_Name: 'Marcus',
Last_Name: 'Orbison',
Prefix: 'Mr.',
Title: 'Travel Coordinator',
City: 'Los Angeles',
State: 'California',
Email: 'marcuso@dx-email.com',
Mobile_Phone: '(213) 555-7098',
Birth_Date: '1982-03-02',
Hire_Date: '2005-05-19',
Status: 'Salaried',
Department: 'Human Resources',
},
{
ID: 28,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '(818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 29,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '(818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
Department: 'IT',
},
{
ID: 32,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '(714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
Department: 'Engineering',
},
{
ID: 33,
First_Name: 'Leah',
Last_Name: 'Simpson',
Prefix: 'Mrs.',
Title: 'Test Coordinator',
City: 'Whittier',
State: 'California',
Email: 'leahs@dx-email.com',
Mobile_Phone: '(562) 559-5830',
Birth_Date: '1983-04-19',
Hire_Date: '2009-02-14',
Status: 'Salaried',
Department: 'Engineering',
},
{
ID: 36,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '(323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
Department: 'Engineering',
},
{
ID: 38,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '(805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
Department: 'Engineering',
},
{
ID: 40,
First_Name: 'Lucy',
Last_Name: 'Ball',
Prefix: 'Ms.',
Title: 'Sales Assistant',
City: 'Pacific Palisades',
State: 'California',
Email: 'lucyb@dx-email.com',
Mobile_Phone: '(310) 555-3357',
Birth_Date: '1986-08-09',
Hire_Date: '2006-07-19',
Status: 'Salaried',
Department: 'Sales',
},
{
ID: 44,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '(925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
Department: 'Sales',
},
{
ID: 45,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '(925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
Department: 'Sales',
},
{
ID: 47,
First_Name: 'Lincoln',
Last_Name: 'Bartlett',
Prefix: 'Mr.',
Title: 'Sales Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'lincolnb@dx-email.com',
Mobile_Phone: '(213) 555-8272',
Birth_Date: '1990-08-02',
Hire_Date: '2012-05-11',
Status: 'Salaried',
Department: 'Sales',
},
{
ID: 48,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '(213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
Department: 'Engineering',
},
{
ID: 50,
First_Name: 'Dallas',
Last_Name: 'Lou',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'dallas@dx-email.com',
Mobile_Phone: '(213) 555-8357',
Birth_Date: '1994-08-19',
Hire_Date: '2012-06-18',
Status: 'Terminated',
Department: 'Shipping',
},
{
ID: 51,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '(213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
Department: 'Engineering',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.card-footer {
display: flex;
padding: 12px;
gap: 8px;
}
.card-footer > * {
flex-grow: 1;
width: 100%
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: var(--dx-color-warning);
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
DevExtreme CardView ships with the following built-in data management options:
- Sorting
- Paging
- Column reordering
- Column visibility control
- Editing
- Filtering
- Searching
- Data selection
Each card within the CardView is customizable.

Backend API
<template>
<DxCardView
:data-source="employees"
key-expr="ID"
:card-min-width="300"
cards-per-row="auto"
card-footer-template="footerTemplate"
ref="cardView"
>
<DxPaging
:page-size="4"
/>
<DxHeaderFilter
:visible="true"
/>
<DxSearchPanel
:visible="true"
/>
<DxSelection mode="multiple"/>
<DxCardCover
:image-expr="imageExpr"
:alt-expr="altExpr"
/>
<DxColumn
data-field="Status"
field-value-template="statusTemplate"
:allow-search="false"
/>
<DxColumn
caption="Full Name"
:allow-filtering="true"
:allow-sorting="true"
:calculate-field-value="calculateFullName"
/>
<DxColumn
caption="Position"
data-field="Title"
/>
<DxColumn
data-field="Department"
/>
<DxColumn
data-field="Mobile_Phone"
/>
<DxColumn
data-field="Email"
field-value-template="emailTemplate"
:allow-search="false"
/>
<DxColumn
caption="Address"
:allow-filtering="true"
:allow-sorting="true"
:calculate-field-value="calculateAddress"
/>
<template
#statusTemplate="{ data }"
>
<div
:class="['status', {
'status--salaried': data.field.value === 'Salaried',
'status--commission': data.field.value === 'Commission',
'status--terminated': data.field.value === 'Terminated',
}]"
>
<span class="indicator"/>
<span>{{ data.field.value }}</span>
</div>
</template>
<template
#emailTemplate="{ data }"
>
<a :href="`mailto:${data.field.value}`">{{ data.field.text }}</a>
</template>
<template
#footerTemplate="{ data }"
>
<div class="card-footer">
<DxButton
text="Call"
icon="tel"
type="default"
styling-mode="contained"
@click="showNotify('Call')"
/>
<DxButton
text="Send Email"
icon="message"
type="default"
styling-mode="contained"
@click="showNotify('Send Email')"
/>
</div>
</template>
</DxCardView>
</template>
<script setup lang="ts">
import DxCardView, {
DxColumn, DxCardCover, DxSelection, DxPaging, DxSearchPanel, DxHeaderFilter,
} from 'devextreme-vue/card-view';
import DxButton from 'devextreme-vue/button';
import notify from 'devextreme/ui/notify';
import { ref } from 'vue';
import type { Employee } from './data.ts';
import { employees } from './data.ts';
function imageExpr({ First_Name, Last_Name }: Employee): string {
return `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`;
}
function altExpr({ First_Name, Last_Name }: Employee): string {
return `Photo of ${First_Name} ${Last_Name}`;
}
function calculateFullName({ First_Name, Last_Name }: Employee): string {
return `${First_Name} ${Last_Name}`;
}
function calculateAddress({ State, City }: Employee): string {
return `${City}, ${State}`;
}
function showNotify(text: string) {
notify({
message: `The "${text}" button is clicked.`,
maxWidth: 560,
});
}
const cardView = ref<DxCardView>();
</script>
<style>
.card-footer {
display: flex;
padding: 12px;
gap: 8px;
}
.card-footer > * {
flex-grow: 1;
width: 100%
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export interface Employee {
ID: number;
First_Name: string;
Last_Name: string;
Prefix: string;
Title: string;
City: string;
State: string;
Email: string;
Mobile_Phone: string;
Birth_Date: string;
Hire_Date: string;
Department: string;
Status: string;
}
export const employees: Employee[] = [{
ID: 3,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 4,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
Department: 'Management',
}, {
ID: 5,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 6,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 7,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 10,
First_Name: 'Kevin',
Last_Name: 'Carter',
Prefix: 'Mr.',
Title: 'Shipping Manager',
City: 'Los Angeles',
State: 'California',
Email: 'kevinc@dx-email.com',
Mobile_Phone: '+1 (213) 555-2840',
Birth_Date: '1978-01-09',
Hire_Date: '2009-08-11',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 14,
First_Name: 'Victor',
Last_Name: 'Norris',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'victorn@dx-email.com',
Mobile_Phone: '+1 (213) 555-9278',
Birth_Date: '1986-07-23',
Hire_Date: '2012-07-23',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 15,
First_Name: 'Mary',
Last_Name: 'Stern',
Prefix: 'Ms.',
Title: 'Shipping Assistant',
City: 'Glendale',
State: 'California',
Email: 'marys@dx-email.com',
Mobile_Phone: '+1 (818) 555-7857',
Birth_Date: '1982-04-08',
Hire_Date: '2012-08-12',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 16,
First_Name: 'Robin',
Last_Name: 'Cosworth',
Prefix: 'Mrs.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'robinc@dx-email.com',
Mobile_Phone: '+1 (818) 555-0942',
Birth_Date: '1981-06-12',
Hire_Date: '2012-09-01',
Status: 'Salaried',
Department: 'Shipping',
}, {
ID: 17,
First_Name: 'Kelly',
Last_Name: 'Rodriguez',
Prefix: 'Ms.',
Title: 'Support Assistant',
City: 'Glendale',
State: 'California',
Email: 'kellyr@dx-email.com',
Mobile_Phone: '+1 (818) 555-9248',
Birth_Date: '1988-05-11',
Hire_Date: '2012-10-13',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 18,
First_Name: 'James',
Last_Name: 'Anderson',
Prefix: 'Mr.',
Title: 'Support Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'jamesa@dx-email.com',
Mobile_Phone: '+1 (323) 555-4702',
Birth_Date: '1987-01-29',
Hire_Date: '2012-10-18',
Status: 'Salaried',
Department: 'Support',
}, {
ID: 20,
First_Name: 'Olivia',
Last_Name: 'Peyton',
Prefix: 'Mrs.',
Title: 'Sales Assistant',
City: 'San Pedro',
State: 'California',
Email: 'oliviap@dx-email.com',
Mobile_Phone: '+1 (310) 555-2728',
Birth_Date: '1981-06-03',
Hire_Date: '2012-05-14',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 21,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 22,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 25,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 26,
First_Name: 'Marcus',
Last_Name: 'Orbison',
Prefix: 'Mr.',
Title: 'Travel Coordinator',
City: 'Los Angeles',
State: 'California',
Email: 'marcuso@dx-email.com',
Mobile_Phone: '+1 (213) 555-7098',
Birth_Date: '1982-03-02',
Hire_Date: '2005-05-19',
Status: 'Salaried',
Department: 'Human Resources',
}, {
ID: 28,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 29,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
Department: 'IT',
}, {
ID: 32,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 33,
First_Name: 'Leah',
Last_Name: 'Simpson',
Prefix: 'Mrs.',
Title: 'Test Coordinator',
City: 'Whittier',
State: 'California',
Email: 'leahs@dx-email.com',
Mobile_Phone: '+1 (562) 559-5830',
Birth_Date: '1983-04-19',
Hire_Date: '2009-02-14',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 36,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 38,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
Department: 'Engineering',
}, {
ID: 40,
First_Name: 'Lucy',
Last_Name: 'Ball',
Prefix: 'Ms.',
Title: 'Sales Assistant',
City: 'Pacific Palisades',
State: 'California',
Email: 'lucyb@dx-email.com',
Mobile_Phone: '+1 (310) 555-3357',
Birth_Date: '1986-08-09',
Hire_Date: '2006-07-19',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 44,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 45,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
Department: 'Sales',
}, {
ID: 47,
First_Name: 'Lincoln',
Last_Name: 'Bartlett',
Prefix: 'Mr.',
Title: 'Sales Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'lincolnb@dx-email.com',
Mobile_Phone: '+1 (213) 555-8272',
Birth_Date: '1990-08-02',
Hire_Date: '2012-05-11',
Status: 'Salaried',
Department: 'Sales',
}, {
ID: 48,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
Department: 'Engineering',
}, {
ID: 50,
First_Name: 'Dallas',
Last_Name: 'Lou',
Prefix: 'Mr.',
Title: 'Shipping Assistant',
City: 'Los Angeles',
State: 'California',
Email: 'dallas@dx-email.com',
Mobile_Phone: '+1 (213) 555-8357',
Birth_Date: '1994-08-19',
Hire_Date: '2012-06-18',
Status: 'Terminated',
Department: 'Shipping',
}, {
ID: 51,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
Department: 'Engineering',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
DevExtreme CardView ships with the following built-in data management options:
- Sorting
- Paging
- Column reordering
- Column visibility control
- Editing
- Filtering
- Searching
- Data selection
Each card within the CardView is customizable.